## caffe 1.0.0~rc4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7)
if(POLICY CMP0046)
  cmake_policy(SET CMP0046 NEW)
endif()
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()

# ---[ Caffe project
project(Caffe C CXX)

# ---[ Caffe version
set(CAFFE_TARGET_VERSION "1.0.0-rc3" CACHE STRING "Caffe logical version")
set(CAFFE_TARGET_SOVERSION "1.0.0-rc3" CACHE STRING "Caffe soname version")
add_definitions(-DCAFFE_VERSION=${CAFFE_TARGET_VERSION})

# ---[ Using cmake scripts and modules
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/Modules)

include(ExternalProject)

include(cmake/Utils.cmake)
include(cmake/Targets.cmake)
include(cmake/Misc.cmake)
include(cmake/Summary.cmake)
include(cmake/ConfigGen.cmake)

# ---[ Options
caffe_option(CPU_ONLY  "Build Caffe without CUDA support" OFF) # TODO: rename to USE_CUDA
caffe_option(USE_CUDNN "Build Caffe with cuDNN library support" ON IF NOT CPU_ONLY)
caffe_option(USE_NCCL "Build Caffe with NCCL library support" OFF)
caffe_option(BUILD_SHARED_LIBS "Build shared libraries" ON)
caffe_option(BUILD_python "Build Python wrapper" ON)
set(python_version "2" CACHE STRING "Specify which Python version to use")
caffe_option(BUILD_matlab "Build Matlab wrapper" OFF IF UNIX OR APPLE)
caffe_option(BUILD_docs   "Build documentation" ON IF UNIX OR APPLE)
caffe_option(BUILD_python_layer "Build the Caffe Python layer" ON)
caffe_option(USE_OPENCV "Build with OpenCV support" ON)
caffe_option(USE_LEVELDB "Build with levelDB" ON)
caffe_option(USE_LMDB "Build with lmdb" ON)
caffe_option(ALLOW_LMDB_NOLOCK "Allow MDB_NOLOCK when reading LMDB files (only if necessary)" OFF)

# ---[ Dependencies
include(cmake/Dependencies.cmake)

# ---[ Flags
if(UNIX OR APPLE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall")
endif()

caffe_set_caffe_link()

if(USE_libstdcpp)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libstdc++")
  message("-- Warning: forcing libstdc++ (controlled by USE_libstdcpp option in cmake)")
endif()

add_definitions(-DGTEST_USE_OWN_TR1_TUPLE)

# ---[ Warnings
caffe_warnings_disable(CMAKE_CXX_FLAGS -Wno-sign-compare -Wno-uninitialized)

# ---[ Config generation
configure_file(cmake/Templates/caffe_config.h.in "${PROJECT_BINARY_DIR}/caffe_config.h")

# ---[ Includes
set(Caffe_INCLUDE_DIR ${PROJECT_SOURCE_DIR}/include)
include_directories(${Caffe_INCLUDE_DIR} ${PROJECT_BINARY_DIR})
include_directories(BEFORE src) # This is needed for gtest.

# ---[ Subdirectories
add_subdirectory(src/gtest)
add_subdirectory(src/caffe)
add_subdirectory(tools)
add_subdirectory(examples)
add_subdirectory(python)
add_subdirectory(matlab)
add_subdirectory(docs)

# ---[ Linter target
add_custom_target(lint COMMAND ${CMAKE_COMMAND} -P ${PROJECT_SOURCE_DIR}/cmake/lint.cmake)

# ---[ pytest target
if(BUILD_python)
  add_custom_target(pytest COMMAND python${python_version} -m unittest discover -s caffe/test WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/python )
  add_dependencies(pytest pycaffe)
endif()

# ---[ Configuration summary
caffe_print_configuration_summary()

# ---[ Export configs generation
caffe_generate_export_configs()

=== Makefile ===
PROJECT := caffe

CONFIG_FILE := Makefile.config
# Explicitly check for the config file, otherwise make -k will proceed anyway.
ifeq ($(wildcard $(CONFIG_FILE)),)
$(error $(CONFIG_FILE) not found. See $(CONFIG_FILE).example.)
endif
include $(CONFIG_FILE)

BUILD_DIR_LINK := $(BUILD_DIR)
ifeq ($(RELEASE_BUILD_DIR),)
	RELEASE_BUILD_DIR := .$(BUILD_DIR)_release
endif
ifeq ($(DEBUG_BUILD_DIR),)
	DEBUG_BUILD_DIR := .$(BUILD_DIR)_debug
endif

DEBUG ?= 0
ifeq ($(DEBUG), 1)
	BUILD_DIR := $(DEBUG_BUILD_DIR)
	OTHER_BUILD_DIR := $(RELEASE_BUILD_DIR)
else
	BUILD_DIR := $(RELEASE_BUILD_DIR)
	OTHER_BUILD_DIR := $(DEBUG_BUILD_DIR)
endif

# All of the directories containing code.
SRC_DIRS := $(shell find * -type d -exec bash -c "find {} -maxdepth 1 \
	\( -name '*.cpp' -o -name '*.proto' \) | grep -q ." \; -print)

# The target shared library name
LIBRARY_NAME := $(PROJECT)
LIB_BUILD_DIR := $(BUILD_DIR)/lib
STATIC_NAME := $(LIB_BUILD_DIR)/lib$(LIBRARY_NAME).a
DYNAMIC_VERSION_MAJOR 		:= 1
DYNAMIC_VERSION_MINOR 		:= 0
DYNAMIC_VERSION_REVISION 	:= 0-rc3
DYNAMIC_NAME_SHORT := lib$(LIBRARY_NAME).so
#DYNAMIC_SONAME_SHORT := $(DYNAMIC_NAME_SHORT).$(DYNAMIC_VERSION_MAJOR)
DYNAMIC_VERSIONED_NAME_SHORT := $(DYNAMIC_NAME_SHORT).$(DYNAMIC_VERSION_MAJOR).$(DYNAMIC_VERSION_MINOR).$(DYNAMIC_VERSION_REVISION)
DYNAMIC_NAME := $(LIB_BUILD_DIR)/$(DYNAMIC_VERSIONED_NAME_SHORT)
COMMON_FLAGS += -DCAFFE_VERSION=$(DYNAMIC_VERSION_MAJOR).$(DYNAMIC_VERSION_MINOR).$(DYNAMIC_VERSION_REVISION)

##############################
# Get all source files
##############################
# CXX_SRCS are the source files excluding the test ones.
CXX_SRCS := $(shell find src/$(PROJECT) ! -name "test_*.cpp" -name "*.cpp")
# CU_SRCS are the cuda source files
CU_SRCS := $(shell find src/$(PROJECT) ! -name "test_*.cu" -name "*.cu")
# TEST_SRCS are the test source files
TEST_MAIN_SRC := src/$(PROJECT)/test/test_caffe_main.cpp
TEST_SRCS := $(shell find src/$(PROJECT) -name "test_*.cpp")
TEST_SRCS := $(filter-out $(TEST_MAIN_SRC), $(TEST_SRCS))
TEST_CU_SRCS := $(shell find src/$(PROJECT) -name "test_*.cu")
GTEST_SRC := src/gtest/gtest-all.cpp
# TOOL_SRCS are the source files for the tool binaries
TOOL_SRCS := $(shell find tools -name "*.cpp")
# EXAMPLE_SRCS are the source files for the example binaries
EXAMPLE_SRCS := $(shell find examples -name "*.cpp")
# BUILD_INCLUDE_DIR contains any generated header files we want to include.
BUILD_INCLUDE_DIR := $(BUILD_DIR)/src
# PROTO_SRCS are the protocol buffer definitions
PROTO_SRC_DIR := src/$(PROJECT)/proto
PROTO_SRCS := $(wildcard $(PROTO_SRC_DIR)/*.proto)
# PROTO_BUILD_DIR will contain the .cc and obj files generated from
# PROTO_SRCS; PROTO_BUILD_INCLUDE_DIR will contain the .h header files
PROTO_BUILD_DIR := $(BUILD_DIR)/$(PROTO_SRC_DIR)
PROTO_BUILD_INCLUDE_DIR := $(BUILD_INCLUDE_DIR)/$(PROJECT)/proto
# NONGEN_CXX_SRCS includes all source/header files except those generated
# automatically (e.g., by proto).
NONGEN_CXX_SRCS := $(shell find \
	src/$(PROJECT) \
	include/$(PROJECT) \
	python/$(PROJECT) \
	matlab/+$(PROJECT)/private \
	examples \
	tools \
	-name "*.cpp" -or -name "*.hpp" -or -name "*.cu" -or -name "*.cuh")
LINT_SCRIPT := scripts/cpp_lint.py
LINT_OUTPUT_DIR := $(BUILD_DIR)/.lint
LINT_EXT := lint.txt
LINT_OUTPUTS := $(addsuffix .$(LINT_EXT), $(addprefix $(LINT_OUTPUT_DIR)/, $(NONGEN_CXX_SRCS)))
EMPTY_LINT_REPORT := $(BUILD_DIR)/.$(LINT_EXT)
NONEMPTY_LINT_REPORT := $(BUILD_DIR)/$(LINT_EXT)
# PY$(PROJECT)_SRC is the python wrapper for $(PROJECT)
PY$(PROJECT)_SRC := python/$(PROJECT)/_$(PROJECT).cpp
PY$(PROJECT)_SO := python/$(PROJECT)/_$(PROJECT).so
PY$(PROJECT)_HXX := include/$(PROJECT)/layers/python_layer.hpp
# MAT$(PROJECT)_SRC is the mex entrance point of matlab package for $(PROJECT)
MAT$(PROJECT)_SRC := matlab/+$(PROJECT)/private/$(PROJECT)_.cpp
ifneq ($(MATLAB_DIR),)
	MAT_SO_EXT := $(shell $(MATLAB_DIR)/bin/mexext)
endif
MAT$(PROJECT)_SO := matlab/+$(PROJECT)/private/$(PROJECT)_.$(MAT_SO_EXT)

##############################
# Derive generated files
##############################
# The generated files for protocol buffers
PROTO_GEN_HEADER_SRCS := $(addprefix $(PROTO_BUILD_DIR)/, \
		$(notdir ${PROTO_SRCS:.proto=.pb.h}))
PROTO_GEN_HEADER := $(addprefix $(PROTO_BUILD_INCLUDE_DIR)/, \
		$(notdir ${PROTO_SRCS:.proto=.pb.h}))
PROTO_GEN_CC := $(addprefix $(BUILD_DIR)/, ${PROTO_SRCS:.proto=.pb.cc})
PY_PROTO_BUILD_DIR := python/$(PROJECT)/proto
PY_PROTO_INIT := python/$(PROJECT)/proto/__init__.py
PROTO_GEN_PY := $(foreach file,${PROTO_SRCS:.proto=_pb2.py}, \
		$(PY_PROTO_BUILD_DIR)/$(notdir $(file)))
# The objects corresponding to the source files
# These objects will be linked into the final shared library, so we
# exclude the tool, example, and test objects.
CXX_OBJS := $(addprefix $(BUILD_DIR)/, ${CXX_SRCS:.cpp=.o})
CU_OBJS := $(addprefix $(BUILD_DIR)/cuda/, ${CU_SRCS:.cu=.o})
PROTO_OBJS := ${PROTO_GEN_CC:.cc=.o}
OBJS := $(PROTO_OBJS) $(CXX_OBJS) $(CU_OBJS)
# tool, example, and test objects
TOOL_OBJS := $(addprefix $(BUILD_DIR)/, ${TOOL_SRCS:.cpp=.o})
TOOL_BUILD_DIR := $(BUILD_DIR)/tools
TEST_CXX_BUILD_DIR := $(BUILD_DIR)/src/$(PROJECT)/test
TEST_CU_BUILD_DIR := $(BUILD_DIR)/cuda/src/$(PROJECT)/test
TEST_CXX_OBJS := $(addprefix $(BUILD_DIR)/, ${TEST_SRCS:.cpp=.o})
TEST_CU_OBJS := $(addprefix $(BUILD_DIR)/cuda/, ${TEST_CU_SRCS:.cu=.o})
TEST_OBJS := $(TEST_CXX_OBJS) $(TEST_CU_OBJS)
GTEST_OBJ := $(addprefix $(BUILD_DIR)/, ${GTEST_SRC:.cpp=.o})
EXAMPLE_OBJS := $(addprefix $(BUILD_DIR)/, ${EXAMPLE_SRCS:.cpp=.o})
# Output files for automatic dependency generation
DEPS := ${CXX_OBJS:.o=.d} ${CU_OBJS:.o=.d} ${TEST_CXX_OBJS:.o=.d} \
	${TEST_CU_OBJS:.o=.d} $(BUILD_DIR)/${MAT$(PROJECT)_SO:.$(MAT_SO_EXT)=.d}
# tool, example, and test bins
TOOL_BINS := ${TOOL_OBJS:.o=.bin}
EXAMPLE_BINS := ${EXAMPLE_OBJS:.o=.bin}
# symlinks to tool bins without the ".bin" extension
TOOL_BIN_LINKS := ${TOOL_BINS:.bin=}
# Put the test binaries in build/test for convenience.
TEST_BIN_DIR := $(BUILD_DIR)/test
TEST_CU_BINS := $(addsuffix .testbin,$(addprefix $(TEST_BIN_DIR)/, \
		$(foreach obj,$(TEST_CU_OBJS),$(basename $(notdir $(obj))))))
TEST_CXX_BINS := $(addsuffix .testbin,$(addprefix $(TEST_BIN_DIR)/, \
		$(foreach obj,$(TEST_CXX_OBJS),$(basename $(notdir $(obj))))))
TEST_BINS := $(TEST_CXX_BINS) $(TEST_CU_BINS)
# TEST_ALL_BIN is the test binary that links caffe dynamically.
TEST_ALL_BIN := $(TEST_BIN_DIR)/test_all.testbin

##############################
# Derive compiler warning dump locations
##############################
WARNS_EXT := warnings.txt
CXX_WARNS := $(addprefix $(BUILD_DIR)/, ${CXX_SRCS:.cpp=.o.$(WARNS_EXT)})
CU_WARNS := $(addprefix $(BUILD_DIR)/cuda/, ${CU_SRCS:.cu=.o.$(WARNS_EXT)})
TOOL_WARNS := $(addprefix $(BUILD_DIR)/, ${TOOL_SRCS:.cpp=.o.$(WARNS_EXT)})
EXAMPLE_WARNS := $(addprefix $(BUILD_DIR)/, ${EXAMPLE_SRCS:.cpp=.o.$(WARNS_EXT)})
TEST_WARNS := $(addprefix $(BUILD_DIR)/, ${TEST_SRCS:.cpp=.o.$(WARNS_EXT)})
TEST_CU_WARNS := $(addprefix $(BUILD_DIR)/cuda/, ${TEST_CU_SRCS:.cu=.o.$(WARNS_EXT)})
ALL_CXX_WARNS := $(CXX_WARNS) $(TOOL_WARNS) $(EXAMPLE_WARNS) $(TEST_WARNS)
ALL_CU_WARNS := $(CU_WARNS) $(TEST_CU_WARNS)
ALL_WARNS := $(ALL_CXX_WARNS) $(ALL_CU_WARNS)

EMPTY_WARN_REPORT := $(BUILD_DIR)/.$(WARNS_EXT)
NONEMPTY_WARN_REPORT := $(BUILD_DIR)/$(WARNS_EXT)

##############################
# Derive include and lib directories
##############################
CUDA_INCLUDE_DIR := $(CUDA_DIR)/include

CUDA_LIB_DIR :=
# add <cuda>/lib64 only if it exists
ifneq ("$(wildcard $(CUDA_DIR)/lib64)","")
	CUDA_LIB_DIR += $(CUDA_DIR)/lib64
endif
CUDA_LIB_DIR += $(CUDA_DIR)/lib

INCLUDE_DIRS += $(BUILD_INCLUDE_DIR) ./src ./include
ifneq ($(CPU_ONLY), 1)
	INCLUDE_DIRS += $(CUDA_INCLUDE_DIR)
	LIBRARY_DIRS += $(CUDA_LIB_DIR)
	LIBRARIES := cudart cublas curand
endif

LIBRARIES += glog gflags protobuf boost_system boost_filesystem m hdf5_hl hdf5

# handle IO dependencies
USE_LEVELDB ?= 1
USE_LMDB ?= 1
USE_OPENCV ?= 1

ifeq ($(USE_LEVELDB), 1)
	LIBRARIES += leveldb snappy
endif
ifeq ($(USE_LMDB), 1)
	LIBRARIES += lmdb
endif
ifeq ($(USE_OPENCV), 1)
	LIBRARIES += opencv_core opencv_highgui opencv_imgproc

	ifeq ($(OPENCV_VERSION), 3)
		LIBRARIES += opencv_imgcodecs
	endif

endif
PYTHON_LIBRARIES ?= boost_python python2.7
WARNINGS := -Wall -Wno-sign-compare

##############################
# Set build directories
##############################

DISTRIBUTE_DIR ?= distribute
DISTRIBUTE_SUBDIRS := $(DISTRIBUTE_DIR)/bin $(DISTRIBUTE_DIR)/lib
DIST_ALIASES := dist
ifneq ($(strip $(DISTRIBUTE_DIR)),distribute)
		DIST_ALIASES += distribute
endif

ALL_BUILD_DIRS := $(sort $(BUILD_DIR) $(addprefix $(BUILD_DIR)/, $(SRC_DIRS)) \
	$(addprefix $(BUILD_DIR)/cuda/, $(SRC_DIRS)) \
	$(LIB_BUILD_DIR) $(TEST_BIN_DIR) $(PY_PROTO_BUILD_DIR) $(LINT_OUTPUT_DIR) \
	$(DISTRIBUTE_SUBDIRS) $(PROTO_BUILD_INCLUDE_DIR))

##############################
# Set directory for Doxygen-generated documentation
##############################
DOXYGEN_CONFIG_FILE ?= ./.Doxyfile
# should be the same as OUTPUT_DIRECTORY in the .Doxyfile
DOXYGEN_OUTPUT_DIR ?= ./doxygen
DOXYGEN_COMMAND ?= doxygen
# All the files that might have Doxygen documentation.
DOXYGEN_SOURCES := $(shell find \
	src/$(PROJECT) \
	include/$(PROJECT) \
	python/ \
	matlab/ \
	examples \
	tools \
	-name "*.cpp" -or -name "*.hpp" -or -name "*.cu" -or -name "*.cuh" -or \
        -name "*.py" -or -name "*.m")
DOXYGEN_SOURCES += $(DOXYGEN_CONFIG_FILE)


##############################
# Configure build
##############################

# Determine platform
UNAME := $(shell uname -s)
ifeq ($(UNAME), Linux)
	LINUX := 1
else ifeq ($(UNAME), Darwin)
	OSX := 1
	OSX_MAJOR_VERSION := $(shell sw_vers -productVersion | cut -f 1 -d .)
	OSX_MINOR_VERSION := $(shell sw_vers -productVersion | cut -f 2 -d .)
endif

# Linux
ifeq ($(LINUX), 1)
	CXX ?= /usr/bin/g++
	GCCVERSION := $(shell $(CXX) -dumpversion | cut -f1,2 -d.)
	# older versions of gcc are too dumb to build boost with -Wuninitalized
	ifeq ($(shell echo | awk '{exit $(GCCVERSION) < 4.6;}'), 1)
		WARNINGS += -Wno-uninitialized
	endif
	# boost::thread is reasonably called boost_thread (compare OS X)
	# We will also explicitly add stdc++ to the link target.
	LIBRARIES += boost_thread stdc++
	VERSIONFLAGS += -Wl,-soname,$(DYNAMIC_VERSIONED_NAME_SHORT) -Wl,-rpath,$(ORIGIN)/../lib
endif

# OS X:
# clang++ instead of g++
# libstdc++ for NVCC compatibility on OS X >= 10.9 with CUDA < 7.0
ifeq ($(OSX), 1)
	CXX := /usr/bin/clang++
	ifneq ($(CPU_ONLY), 1)
		CUDA_VERSION := $(shell $(CUDA_DIR)/bin/nvcc -V | grep -o 'release [0-9.]*' | tr -d '[a-z ]')
		ifeq ($(shell echo | awk '{exit $(CUDA_VERSION) < 7.0;}'), 1)
			CXXFLAGS += -stdlib=libstdc++
			LINKFLAGS += -stdlib=libstdc++
		endif
		# clang throws this warning for cuda headers
		WARNINGS += -Wno-unneeded-internal-declaration
		# 10.11 strips DYLD_* env vars so link CUDA (rpath is available on 10.5+)
		OSX_10_OR_LATER   := $(shell [ $(OSX_MAJOR_VERSION) -ge 10 ] && echo true)
		OSX_10_5_OR_LATER := $(shell [ $(OSX_MINOR_VERSION) -ge 5 ] && echo true)
		ifeq ($(OSX_10_OR_LATER),true)
			ifeq ($(OSX_10_5_OR_LATER),true)
				LDFLAGS += -Wl,-rpath,$(CUDA_LIB_DIR)
			endif
		endif
	endif
	# gtest needs to use its own tuple to not conflict with clang
	COMMON_FLAGS += -DGTEST_USE_OWN_TR1_TUPLE=1
	# boost::thread is called boost_thread-mt to mark multithreading on OS X
	LIBRARIES += boost_thread-mt
	# we need to explicitly ask for the rpath to be obeyed
	ORIGIN := @loader_path
	VERSIONFLAGS += -Wl,-install_name,@rpath/$(DYNAMIC_VERSIONED_NAME_SHORT) -Wl,-rpath,$(ORIGIN)/../../build/lib
else
	ORIGIN := \$$ORIGIN
endif

# Custom compiler
ifdef CUSTOM_CXX
	CXX := $(CUSTOM_CXX)
endif

# Static linking
ifneq (,$(findstring clang++,$(CXX)))
	STATIC_LINK_COMMAND := -Wl,-force_load $(STATIC_NAME)
else ifneq (,$(findstring g++,$(CXX)))
	STATIC_LINK_COMMAND := -Wl,--whole-archive $(STATIC_NAME) -Wl,--no-whole-archive
else
  # The following line must not be indented with a tab, since we are not inside a target

=== caffe/CMakeLists.txt ===
# generate protobuf sources
file(GLOB proto_files proto/*.proto)
caffe_protobuf_generate_cpp_py(${proto_gen_folder} proto_srcs proto_hdrs proto_python ${proto_files})

# include python files either to force generation
add_library(proto STATIC ${proto_hdrs} ${proto_srcs} ${proto_python})
set(Caffe_LINKER_LIBS proto ${Caffe_LINKER_LIBS}) # note, crucial to prepend!
caffe_default_properties(proto)

# --[ Caffe library

# creates 'test_srcs', 'srcs', 'test_cuda', 'cuda' lists
caffe_pickup_caffe_sources(${PROJECT_SOURCE_DIR})

if(HAVE_CUDA)
  caffe_cuda_compile(cuda_objs ${cuda})
  list(APPEND srcs ${cuda_objs} ${cuda})
endif()

add_library(caffe ${srcs})
target_link_libraries(caffe proto ${Caffe_LINKER_LIBS})
caffe_default_properties(caffe)
set_target_properties(caffe PROPERTIES
    VERSION   ${CAFFE_TARGET_VERSION}
    SOVERSION ${CAFFE_TARGET_SOVERSION}
    )

# ---[ Tests
 add_subdirectory(test)

# ---[ Install
install(DIRECTORY ${Caffe_INCLUDE_DIR}/caffe DESTINATION include)
install(FILES ${proto_hdrs} DESTINATION include/caffe/proto)
install(TARGETS caffe proto EXPORT CaffeTargets DESTINATION lib)

file(WRITE ${PROJECT_BINARY_DIR}/__init__.py)
list(APPEND proto_python ${PROJECT_BINARY_DIR}/__init__.py)
install(PROGRAMS ${proto_python} DESTINATION python/caffe/proto)

=== gtest/CMakeLists.txt ===
add_library(gtest STATIC EXCLUDE_FROM_ALL gtest.h gtest-all.cpp)
caffe_default_properties(gtest)

#add_library(gtest_main gtest_main.cc)
#target_link_libraries(gtest_main gtest)

## caffe 1.0.0~rc3+20161127-g24d2f67

=== debian/changelog ===
caffe (1.0.0~rc3+20161127-g24d2f67-4) unstable; urgency=medium

  * Avoid autopkgtest failure by fixing stderr redirection.

 -- Zhou Mo <cdluminate@gmail.com>  Fri, 09 Dec 2016 02:06:23 +0000

caffe (1.0.0~rc3+20161127-g24d2f67-3) unstable; urgency=medium

  * Refresh symbols control file from buildd's log.
  * Temporarily remove unused symbols file for kfreebsd-{amd64,i386}.
  * Mark caffe-doc as "Multi-Arch: foreign".
  * Redirect all autopkgtest scripts' stderr to stdout in order to
    make CI happy. Test scripts are considered failed as long as they
    produced output to stderr.

 -- Zhou Mo <cdluminate@gmail.com>  Sat, 03 Dec 2016 04:10:30 +0000

caffe (1.0.0~rc3+20161127-g24d2f67-2) unstable; urgency=medium

  * Install docker directory to caffe-doc package.
  * Refresh symbols control files for amd64 and i386.
  * Upload to unstable.

 -- Zhou Mo <cdluminate@gmail.com>  Tue, 29 Nov 2016 01:24:19 +0000

caffe (1.0.0~rc3+20161127-g24d2f67-1) experimental; urgency=medium

  * Import upstream snapshot.
  * Add patch: fix-more-float-comparison-precision-issue2 to fix more float
    point number comparison issue.
  * Refresh symbols control files.

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 28 Nov 2016 11:07:46 +0000

caffe (1.0.0~rc3+20160930-ga7f950b-3) experimental; urgency=medium

  * Refresh symbols control file for i386 and ppc64el.
  * Move OpenBLAS and Atlas to Dependency of caffe-cpu, both prior to
    Generic BLAS (libblas3). That means users are forced to use one of
    optimized BLAS packages as long as available.
  * Update README.Debian .

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 28 Nov 2016 02:08:10 +0000

caffe (1.0.0~rc3+20160930-ga7f950b-2) experimental; urgency=medium

  * Update autopkgtest scripts.
  * Refresh symbols control file for the following architectures:
    + amd64 (default), i386, ppc64el, kfreebsd-{amd64,i386}.
  * Add python3-protobuf to B-D, which is available since protobuf_3.0.0-8 .
  * Add description for several patches.

 -- Zhou Mo <cdluminate@gmail.com>  Sat, 26 Nov 2016 04:24:25 +0000

caffe (1.0.0~rc3+20160930-ga7f950b-1) experimental; urgency=medium

  * Import upstream snapshot (a7f950baafd7657732a40286e6db89f2c3baef63).
  * Fix changelog of the previous revision:
    - Fix typo: comtrol -> control .
    - Explain why git and libboost-dev are added as B-D.
  * Add patch fix-more-float-comparison-precision-issue, which fixes
    the float comparison precision problem in some of the unit tests.
  * Update manpage with new command line options added.
  * Update bash completion script according to command line option changes.
  * Refresh symbols control file.
  * Update description for caffe-doc.
  * Override a false-positive lintian warning.
  * Override dh_install with --list-missing.

 -- Zhou Mo <cdluminate@gmail.com>  Sun, 02 Oct 2016 12:31:15 +0000

caffe (1.0.0~rc3+20160715-g42cd785-1) experimental; urgency=medium

  * Import upstream snapshot (42cd785e4b5ed824a9b2a02a19aa534042b64325).
  * Suggest OpenBLAS/Atlas library for metapackage caffe-cpu.
  * Update manpage d/man/caffe.1 .
  * Comment out "-pedantic" from rules to reduce the size of build log.
  * Drop cherry-picked patches, already included in this new snapshot:
    - dont-set-map-size-1TB-in-db-lmdb
    - print-to-stderr-for-example-LMDB-code
    - update-MNIST-example-to-use-new-DB-classes
  * Remove patch fix-spelling-error, which was merged by upstream.
  * Refresh patch cmake-fix-python-module-installdir.
  * Refresh symbols control file.
  * Override dh_fixperms to remove executable bit from several python scripts.
  * Add git and libboost-dev to B-D, to make cmake happy.
  * Add patch: cmake-avoid-argument-missing .

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 01 Aug 2016 04:37:02 +0000

caffe (1.0.0~rc3-4) experimental; urgency=medium

  * Cherry-pick upstream fixes for map size issue.
    - dont-set-map-size-1TB-in-db-lmdb
    - print-to-stderr-for-example-LMDB-code
    - update-MNIST-example-to-use-new-DB-classes
  * Update symbols control file, diverge symbols control file for ppc64el.
  * Synchronize packaging with src:caffe-contrib (= 1.0.0~rc3-2).

 -- Zhou Mo <cdluminate@gmail.com>  Sun, 10 Jul 2016 12:10:07 +0000

caffe (1.0.0~rc3-3) experimental; urgency=medium

  * Remove octave related packages and corresponding builds, because
    upstream support for octave is limited.
  * Fix typo in package descriptions, update descriptions.
  * Update rules.
  * Add symbols control file for libcaffe.so .
  * Update README.Debian .

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 04 Jul 2016 14:47:20 +0000

caffe (1.0.0~rc3-2) experimental; urgency=low

  * d/control
    - Rename binary package caffe-cpu to caffe-tools-cpu.
    - Create metapackage "caffe-cpu".
    - Update package descriptions.
    - Add B-D: liboctave-dev, octave-pkg-dev.
    - Bump python-caffe-cpu to python3-caffe-cpu.
    - Suggest caffe-doc for libcaffe-cpu-dev.
  * d/rules
    - Compile octave binary, however octave package is
      temporarily commented out bacause it's WIP.
    - Include defs.make from package 'octave-pkg-dev' for Octave
      related variables.
    - Bump from python2 build to python3 build.
    - change the compiling target order of override_dh_auto_build-arch.
  * d/man
    - Refresh manpage debian/man/caffe.1 , generated by txt2man with
      template file debian/man/caffe.txt
    - Remove unnecessary man pages.
  * d/patch
    - Update patches due to python2->python3 transition.
    - Update forward status in patch headers.
    - Add new patch cmake-octave-fix-library, which fixes python3
      library name for mkoctfile.
  * d/tests
    - Add python3 interface B-D runtime-dependencies for testsuite.
    - Add test suite: python3caffetestsuite .
    - Update testsuite: simple .
  * Add install control files for octave-caffe-cpu.
  * Update debian/clean.
  * Update bash completion script for caffe.
  * Remove d/TODO.
  * Upload to experimental. The -1 version is an accident.



=== debian/control ===
Source: caffe
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Zhou Mo <cdluminate@gmail.com>
Build-Depends-Indep: doxygen,
                     doxygen-latex
Build-Depends: bc,
               cmake,
               bash-completion,
               debhelper (>=9),
               dh-python,
               git,
# libboost-all-dev (>= 1.55) - we merely pull partial boost stack, the really needed part.
               libboost-dev,
               libboost-filesystem-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libboost-python-dev,
               libgflags-dev,
               libgoogle-glog-dev,
               libhdf5-dev,
               libleveldb-dev,
               liblmdb-dev,
# switch libblas.so.3 between Atlas and OpenBLAS with update-alternatives
               libblas-dev | libblas.so,
               libopencv-dev (>= 2.4),
               libprotobuf-dev,
               libprotoc-dev,
               libsnappy-dev,
               protobuf-compiler,
# python3 depssome of them are not B-D but we need them as runtime-deps to pass the testsuite
               python3-dev,
               python3-numpy,
               cython3,
               ipython3,
               python3,
               python3-skimage,
               python3-protobuf,
               python3-dateutil,
               python3-gflags,
               python3-h5py,
               python3-leveldb,
               python3-matplotlib,
               python3-networkx,
               python3-nose,
#              python3-opencv, # this is recommended if available but it doesn't block
               python3-pandas,
               python3-pil,
               python3-scipy,
               python3-six,
               python3-yaml,
Standards-Version: 3.9.8
Homepage: http://caffe.berkeleyvision.org
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/caffe.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/caffe.git
X-Python-Version: >= 3.3

Package: caffe-cpu
Section: metapackages
Architecture: any
Depends: caffe-tools-cpu   (= ${binary:Version}),
         python3-caffe-cpu (= ${binary:Version}),
         libcaffe-cpu1     (= ${binary:Version}),
# the default libblas.so.3 comes from pkg:libblas3, with low performance.
         libopenblas-base | libatlas3-base | libblas.so.3 ,
         ${misc:Depends},
Suggests: libcaffe-cpu-dev (= ${binary:Version}),
          caffe-doc        (= ${binary:Version}),
Conflicts: caffe-cuda
Description: Fast, open framework for Deep Learning (Meta)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley Vision
 and Learning Center (BVLC) and community contributors.
 .
 This metapackage pulls CPU_ONLY version of caffe:
  * caffe-tools-cpu
  * libcaffe-cpu*
  * python3-caffe-cpu 
 And suggests these packages:
  * libcaffe-cpu-dev
  * caffe-doc
 .
 Note, this CPU_ONLY version cannot co-exist with the CUDA version.

Package: caffe-tools-cpu
Architecture: any
Multi-Arch: foreign
Depends: libcaffe-cpu1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: caffe-tools-cuda
Description: Tools for fast, open framework for Deep Learning (CPU_ONLY)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley Vision
 and Learning Center (BVLC) and community contributors.
 .
 It contains caffe executables, configured as CPU_ONLY.

Package: libcaffe-cpu1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libcaffe-cuda1
Description: library of Caffe, deep learning framework (CPU_ONLY)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley Vision
 and Learning Center (BVLC) and community contributors.
 .
 It contains caffe shared library, configured as CPU_ONLY.

Package: libcaffe-cpu-dev
Section: libdevel
Architecture: any
Multi-Arch: foreign
Conflicts: libcaffe-cuda-dev
Depends: libcaffe-cpu1 (= ${binary:Version}), ${misc:Depends}
Suggests: caffe-doc
Description: development files for Caffe (CPU_ONLY)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley Vision
 and Learning Center (BVLC) and community contributors.
 .
 It contains development files of caffe.

Package: python3-caffe-cpu
Section: python
Architecture: any
Multi-Arch: foreign
Depends: libcaffe-cpu1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         ${python3:Depends},
Conflicts: python3-caffe-cuda
Description: Python3 interface of Caffe (CPU_ONLY)
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley Vision
 and Learning Center (BVLC) and community contributors.
 .
 It contains python3 interface of caffe, configured as CPU_ONLY.

Package: caffe-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Caffe's doxygen docs and examples
 Caffe is a deep learning framework made with expression, speed,
 and modularity in mind. It is developed by the Berkeley Vision
 and Learning Center (BVLC) and community contributors.
 .
 This package contains doxygen documents (both HTML version and
 PDF version) and some other documents and examples.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# Hardening Caffe according to https://wiki.debian.org/Hardening
export DEB_BUILD_MAINT_OPTIONS   = hardening=+all
export DEB_CFLAGS_MAINT_APPEND   = -Wall #-pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall #-pedantic
export DEB_LDFLAGS_MAINT_APPEND  = -Wl,--as-needed

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
RULES         := debian/rules
ORIG_SOURCE   := "https://github.com/BVLC/caffe/archive/rc3.tar.gz" # FIXME
CAFFE_SOVER   := 1.0.0-rc3
BUILDDIR      := "caffe_cpu_build"

TEMPLATES     := $(wildcard debian/*.in)
AUTOGEN       := $(patsubst %.in,%,$(TEMPLATES))

## CMake Configuration Template.
## * PLEASE sync this common template with caffe-contrib source.
CMAKE_CONFIGURE_TEMPLATE = \
	-DALLOW_LMDB_NOLOCK=OFF \
	-DBLAS="Generic" \
	-DBUILD_SHARED_LIBS=ON \
	-DBUILD_docs=OFF \
	-DBUILD_matlab=OFF \
	-DBUILD_python=ON \
	-DBUILD_python_layer=ON \
	-Dpython_version="3" \
	-DCMAKE_BUILD_TYPE="Release" \
	-DCMAKE_C_FLAGS="$(CFLAGS) $(CPPFLAGS)" \
	-DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CPPFLAGS)" \
	-DCMAKE_SKIP_RPATH=TRUE \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DUSE_CUDNN=OFF \
	-DUSE_LEVELDB=ON \
	-DUSE_LMDB=ON \
	-DUSE_OPENCV=ON \
	-DCPU_ONLY=$(FILL_THIS_BLANK) \
	-DCMAKE_INSTALL_PREFIX="/usr"
# These flags are for cuda version but please keep them
#	-DCUDA_ARCH_NAME="All"
#	-DCMAKE_CXX_COMPILER=g++-5
#	-DCMAKE_C_COMPILER=gcc-5

CONFFLAG_CPU = \
	$(CMAKE_CONFIGURE_TEMPLATE) \
	-DCPU_ONLY=ON

%:: %.in
	perl -p \
	-e 's{#CAFFE_CONFIGURE#}{caffe_cpu}g;' \
	-e 's{#CAFFE_SOVER#}{$(CAFFE_SOVER)}g;' \
	-e 's{#DEB_HOST_MULTIARCH#}{$(DEB_HOST_MULTIARCH)}g;' \
	< $< > $@

%:
	dh $@ \
		--parallel \
		--buildsystem=cmake \
		--with python3,bash-completion

override_dh_auto_configure: $(AUTOGEN)
	dh_auto_configure --builddirectory=$(BUILDDIR) \
		-- $(CONFFLAG_CPU)

override_dh_auto_clean:
	dh_auto_clean --builddirectory=$(BUILDDIR)
	-$(RM) -rf python/caffe/proto/ doxygen
	-$(RM) python/caffe/_caffe.so

override_dh_auto_build-indep:
	doxygen .Doxyfile # we don't use BUILD_DOC provided by upstream cmake
	$(MAKE) -C doxygen/latex/
	sed -i -e 's/cdn.mathjax.org/127.0.0.1/g' docs/_layouts/default.html # lintian privacy
	sed -i -e 's/code.jquery.com/127.0.0.1/g' examples/web_demo/templates/index.html # lintian privacy
	sed -i -e 's/netdna.bootstrapcdn.com/127.0.0.1/g' examples/web_demo/templates/index.html # lintian privacy
	find doxygen/html -name 'jquery.js' -delete # lintian embedded-javascript
	find docs -size 0 -delete # lintian zero-byte-file
	find docs -name '.gitignore' -delete # lintian vcs-control-file
	gzip -d examples/finetune_flickr_style/flickr_style.csv.gz # lintian gzip timestamp
	gzip -n ./examples/finetune_flickr_style/flickr_style.csv # ditto

override_dh_auto_build-arch:
	dh_auto_build --builddirectory=$(BUILDDIR) \
		-- caffe pycaffe test.testbin all

# In the test phase, we need to set LD_LIBRARY_PATH properly
# for those test ELFs linked with libcaffe.so.X
override_dh_auto_test-arch:
	dh_auto_test --builddirectory=$(BUILDDIR) \
		-- runtest LD_LIBRARY_PATH=$(BUILDDIR)/lib/ 
override_dh_auto_test-indep:

override_dh_python3:
	dh_python3 --requires=python/requirements.txt
	dh_numpy3

override_dh_install:
	dh_install --list-missing

override_dh_auto_install:
	dh_auto_install --builddirectory=$(BUILDDIR) -- install

override_dh_makeshlibs:
	dh_makeshlibs --package=python3-caffe-cpu -X/usr/lib/python
	dh_makeshlibs --remaining-packages

override_dh_fixperms:
	dh_fixperms
	chmod -x debian/tmp/usr/lib/python3/dist-packages/caffe/proto/caffe_pb2.py
	chmod -x debian/tmp/usr/lib/python3/dist-packages/caffe/proto/__init__.py

get-orig-source:
	wget -c $(ORIG_SOURCE) -O caffe_1.0.0~rc3.orig.tar.gz # FIXME

## caffe 1.0.0~rc4

=== debian/changelog ===
caffe (1.0.0~rc4-1ubuntu1) zesty; urgency=medium

  * Turn off arch autotests as yet as they segfault.

 -- Bhavani Shankar <bhavi@ubuntu.com>  Thu, 09 Feb 2017 08:42:23 +0530

caffe (1.0.0~rc4-1) unstable; urgency=medium

  * New upstream release.
  * Update URL for get-orig-source target in rules.
  * Bump debhelper compat to 10.
  * Patch: add cmake-bump-soversion-to-rc4.patch to fix upstream soversion.
  * Rules: CAFFE_SOVER is `1.0.0-rc4` now.
  * Get rid of symbols control files to avoid endless FTBFS bugs caused
    by symbols change of C++ shared library.
  * Add the missing pytest target in override_dh_auto_test-arch.
  * Update LD_LIBRARY_PATH for dh_auto_test.
  * Rules: patch refman.tex before compiling to avoid pdflatex error.
  * Rules: remove all __pycache__ directories on clean.
  * Refresh lintian overrides.

 -- Zhou Mo <cdluminate@gmail.com>  Sat, 21 Jan 2017 11:26:37 +0000

caffe (1.0.0~rc3+20161127-g24d2f67-5) unstable; urgency=medium

  * Add patch: cmake-link-correct-python-lib.patch to fix FTBFS.
    (Closes: #850989).

 -- Zhou Mo <cdluminate@gmail.com>  Thu, 12 Jan 2017 04:38:30 +0000

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: caffe
 Section: science
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Zhou Mo <cdluminate@gmail.com>
 Build-Depends-Indep: doxygen,
                      doxygen-latex
 Build-Depends: bc,
                cmake,
                bash-completion,
-               debhelper (>=9),
+               debhelper (>=10),
                dh-python,
                git,
 # libboost-all-dev (>= 1.55) - we merely pull partial boost stack, the really needed part.

=== debian/rules ===
--- 
+++ 
@@ -10,8 +10,8 @@
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 RULES         := debian/rules
-ORIG_SOURCE   := "https://github.com/BVLC/caffe/archive/rc3.tar.gz" # FIXME
-CAFFE_SOVER   := 1.0.0-rc3
+ORIG_SOURCE   := "https://github.com/BVLC/caffe/archive/rc4.tar.gz"
+CAFFE_SOVER   := 1.0.0-rc4
 BUILDDIR      := "caffe_cpu_build"
 
 TEMPLATES     := $(wildcard debian/*.in)
@@ -69,9 +69,11 @@
 	dh_auto_clean --builddirectory=$(BUILDDIR)
 	-$(RM) -rf python/caffe/proto/ doxygen
 	-$(RM) python/caffe/_caffe.so
+	-find . -type d -name '__pycache__' -exec rm -rf '{}' +
 
 override_dh_auto_build-indep:
 	doxygen .Doxyfile # we don't use BUILD_DOC provided by upstream cmake
+	sed -i -e 's/]{hyperref}/,draft]{hyperref}/g' doxygen/latex/refman.tex # patch the tex source to avoid a pdflatex compilation error
 	$(MAKE) -C doxygen/latex/
 	sed -i -e 's/cdn.mathjax.org/127.0.0.1/g' docs/_layouts/default.html # lintian privacy
 	sed -i -e 's/code.jquery.com/127.0.0.1/g' examples/web_demo/templates/index.html # lintian privacy
@@ -88,9 +90,9 @@
 
 # In the test phase, we need to set LD_LIBRARY_PATH properly
 # for those test ELFs linked with libcaffe.so.X
-override_dh_auto_test-arch:
-	dh_auto_test --builddirectory=$(BUILDDIR) \
-		-- runtest LD_LIBRARY_PATH=$(BUILDDIR)/lib/ 
+override_dh_auto_test-arch: # Disable for now due to segfault.
+	#dh_auto_test --builddirectory=$(BUILDDIR) \
+	#	-- runtest pytest LD_LIBRARY_PATH=$(shell pwd)/$(BUILDDIR)/lib/ 
 override_dh_auto_test-indep:
 
 override_dh_python3:
@@ -113,4 +115,4 @@
 	chmod -x debian/tmp/usr/lib/python3/dist-packages/caffe/proto/__init__.py
 
 get-orig-source:
-	wget -c $(ORIG_SOURCE) -O caffe_1.0.0~rc3.orig.tar.gz # FIXME
+	wget -c $(ORIG_SOURCE) -O caffe_1.0.0~rc4.orig.tar.gz
